diff -Naur -X diff_ignore rsync-3.0.6_base/receiver.c rsync/receiver.c
--- rsync-3.0.6_base/receiver.c	2010-10-25 14:18:07.000000000 -0400
+++ rsync/receiver.c	2018-05-21 13:20:01.000000000 -0400
@@ -20,11 +20,22 @@
  */
 
 #include "rsync.h"
+// For statfs():
+#include <sys/param.h>
+#include <sys/mount.h>
+
+// For _PATH_RSRCFORKSPEC
+#include <sys/paths.h>
+// For XATTR_NOFOLLOW
+#include <sys/xattr.h>
+// For dirname()
+#include <libgen.h>
 
 extern int verbose;
 extern int dry_run;
 extern int do_xfers;
 extern int am_server;
+extern int rcvr_is_non_local_server;
 extern int do_progress;
 extern int inc_recurse;
 extern int log_before_transfer;
@@ -39,6 +50,9 @@
 extern int preserve_hard_links;
 extern int preserve_perms;
 extern int preserve_xattrs;
+extern int fs_supports_native_xattrs;
+extern int pc_name_max;
+extern int force_change;
 extern int basis_dir_cnt;
 extern int make_backups;
 extern int cleanup_got_literal;
@@ -58,6 +72,7 @@
 extern char sender_file_sum[MAX_DIGEST_LEN];
 extern struct file_list *cur_flist, *first_flist, *dir_flist;
 extern struct filter_list_struct daemon_filter_list;
+extern int dont_csum_data_buffer;
 
 static struct bitbag *delayed_bits = NULL;
 static int phase = 0, redoing = 0;
@@ -65,6 +80,17 @@
 /* We're either updating the basis file or an identical copy: */
 static int updating_basis_or_equiv;
 
+#ifdef PARSEABLE_OUTPUT
+struct timeval last_update;
+static unsigned long msdiff(struct timeval *t1, struct timeval *t2)
+{
+	return (t2->tv_sec - t1->tv_sec) * 1000L
+	+ (t2->tv_usec - t1->tv_usec) / 1000;
+}
+#endif
+#define TMPNAME_SUFFIX ".XXXXXX"
+#define TMPNAME_SUFFIX_LEN ((int)sizeof TMPNAME_SUFFIX - 1)
+
 /*
  * get_tmpname() - create a tmp filename for a given filename
  *
@@ -90,6 +116,7 @@
 {
 	int maxname, added, length = 0;
 	const char *f;
+	char *suf;
 
 	if (tmpdir) {
 		/* Note: this can't overflow, so the return value is safe */
@@ -106,14 +133,20 @@
 		}
 	} else
 		f = fname;
-	fnametmp[length++] = '.';
+	
+	// Avoid prepending the temporary file name with a "." if the name already
+	// starts with a dot, and underscore, or starts with "Apple". Some filesystems
+	// reject filenames that start with .., ._, and .Apple
+	if ( f[0] != '.' && f[0] != '_' && strncasecmp(f, "Apple", 5) != 0)
+		fnametmp[length++] = '.';
 
 	/* The maxname value is bufsize, and includes space for the '\0'.
 	 * (Note that NAME_MAX get -8 for the leading '.' above.) */
-	maxname = MIN(MAXPATHLEN - 7 - length, NAME_MAX - 8);
+	maxname = MIN(MAXPATHLEN - length - TMPNAME_SUFFIX_LEN,
+				  pc_name_max - 1 - TMPNAME_SUFFIX_LEN);
 
-	if (maxname < 1) {
-		rprintf(FERROR_XFER, "temporary filename too long: %s\n", fname);
+	if (maxname < 0) {
+		rprintf(FERROR_XFER, "temporary filename too long: %s\n", full_fname(fname));
 		fnametmp[0] = '\0';
 		return 0;
 	}
@@ -121,7 +154,19 @@
 	added = strlcpy(fnametmp + length, f, maxname);
 	if (added >= maxname)
 		added = maxname - 1;
-	memcpy(fnametmp + length + added, ".XXXXXX", 8);
+	suf = fnametmp + length + added;
+	
+	/* Trim any dangling high-bit chars if the first-trimmed char (if any) is
+	* also a high-bit char, just in case we cut into a multi-byte sequence. */
+	if ((int)f[added] & 0x80) {
+		while ((int)suf[-1] & 0x80)
+			suf--;
+	}
+	/* trim one trailing dot before our suffix's dot */
+	if (suf[-1] == '.')
+		suf--;
+	
+	memcpy(suf, TMPNAME_SUFFIX, TMPNAME_SUFFIX_LEN+1);
 
 	return 1;
 }
@@ -133,6 +178,7 @@
 int open_tmpfile(char *fnametmp, const char *fname, struct file_struct *file)
 {
 	int fd;
+	char *parent = dirname((char *)fname);
 
 	if (!get_tmpname(fnametmp, fname))
 		return -1;
@@ -155,9 +201,43 @@
 	}
 #endif
 
+#ifdef SUPPORT_FORCE_CHANGE
+	int saved_errno = errno;
+	errno = 0;
+	if (fd == -1) {
+		if (parent == NULL) {
+			rprintf(FINFO, "DEBUG: open_tmpfile: Parent of %s is NULL! (%d)\n", full_fname(fname), errno);
+		} else {
+			stat_x sx;
+			if (do_stat(parent, &sx.st) < 0)
+				rprintf(FINFO, "DEBUG: open_tmpfile: Failed to stat %s! (%d)\n", full_fname(parent), errno);
+			else {
+				
+				if (force_change && make_mutable(parent, sx.st.st_mode, sx.st.st_flags, force_change) > 0) {
+					fd = do_mkstemp(fnametmp, file->mode & INITACCESSPERMS);
+					undo_make_mutable(parent, sx.st.st_flags);
+				} else if (force_change && !(force_change & SYS_IMMUTABLE) && sx.st.st_flags & SYS_IMMUTABLE) {
+					rprintf(FINFO, "open_tmpfile: Failed to unlock %s, it is system immutable. Skipping its contents.\n", full_fname(parent));
+					return -1;
+				} else {
+					rprintf(FINFO, "DEBUG: open_tmpfile: Failed to unlock %s (%d)\n", full_fname(parent), errno);
+				}
+			}
+		}
+	}
+	errno = saved_errno;
+#endif
+
 	if (fd == -1) {
-		rsyserr(FERROR_XFER, errno, "mkstemp %s failed",
+		rsyserr(FERROR_XFER, errno, "open_tmpfile: mkstemp %s failed",
 			full_fname(fnametmp));
+		if (errno == EINVAL) {
+			saved_errno = errno;
+			if (unlink(fnametmp) != 0)
+				rsyserr(FERROR_XFER, errno, "open_tmpfile: failed to unlink %s",
+						full_fname(fnametmp));
+			errno = saved_errno;
+		}
 		return -1;
 	}
 
@@ -177,6 +257,13 @@
 	int32 i;
 	char *map = NULL;
 
+	if (verbose > 1) {
+		fprintf(stderr, "receive_data: Receiving data for %s, total size: %.0f.\n", (fd_r >= 0 && size_r > 0) ? fname_r : fname, (double)total_size);
+		if (fd_r >= 0)
+			fprintf(stderr, " Comparing to existing file of size: %.0f\n", (fd_r >= 0 && size_r > 0) ? (double)size_r : (double)total_size);
+		fprintf(stderr, "\n");
+	}
+
 	read_sum_head(f_in, &sum);
 
 	if (fd_r >= 0 && size_r > 0) {
@@ -213,7 +300,7 @@
 		}
 		offset = sum.flength;
 		if (fd != -1 && (j = do_lseek(fd, offset, SEEK_SET)) != offset) {
-			rsyserr(FERROR_XFER, errno, "lseek of %s returned %.0f, not %.0f",
+			rsyserr(FERROR_XFER, errno, "receive_data: lseek of %s returned %.0f, not %.0f",
 				full_fname(fname), (double)j, (double)offset);
 			exit_cleanup(RERR_FILEIO);
 		}
@@ -232,11 +319,24 @@
 			stats.literal_data += i;
 			cleanup_got_literal = 1;
 
-			sum_update(data, i);
-
+			if (dont_csum_data_buffer == 0)
+				sum_update(data, i);
+			
 			if (fd != -1 && write_file(fd,data,i) != i)
 				goto report_write_error;
 			offset += i;
+			stats.total_transferred_size += i;
+#ifdef PARSEABLE_OUTPUT
+			if (!rcvr_is_non_local_server) {
+				struct timeval now;
+				gettimeofday(&now, NULL);
+				unsigned long time_diff = msdiff(&last_update, &now);
+				if (time_diff > 500) {
+					last_update = now;
+					fprintf(stderr, "S;;;STATS;;;TTS;;;%lld;;;FC;;;%d;;;CF;;;%s\n", stats.total_transferred_size, stats.num_transferred_files, fname);
+				}
+			}
+#endif
 			continue;
 		}
 
@@ -258,7 +358,8 @@
 			map = map_ptr(mapbuf,offset2,len);
 
 			see_token(map, len);
-			sum_update(map, len);
+			if (dont_csum_data_buffer == 0)
+				sum_update(map, len);
 		}
 
 		if (updating_basis_or_equiv) {
@@ -269,7 +370,7 @@
 				offset += len;
 				if ((pos = do_lseek(fd, len, SEEK_CUR)) != offset) {
 					rsyserr(FERROR_XFER, errno,
-						"lseek of %s returned %.0f, not %.0f",
+						"receive_data: lseek of %s returned %.0f, not %.0f",
 						full_fname(fname),
 						(double)pos, (double)offset);
 					exit_cleanup(RERR_FILEIO);
@@ -280,16 +381,29 @@
 		if (fd != -1 && map && write_file(fd, map, len) != (int)len)
 			goto report_write_error;
 		offset += len;
+
+		stats.total_transferred_size += len;
+#ifdef PARSEABLE_OUTPUT
+		if (!rcvr_is_non_local_server) {
+			struct timeval now;
+			gettimeofday(&now, NULL);
+			unsigned long time_diff = msdiff(&last_update, &now);
+			if (time_diff > 500) {
+				last_update = now;
+				fprintf(stderr, "S;;;STATS;;;TTS;;;%lld;;;FC;;;%d;;;CF;;;%s\n", stats.total_transferred_size, stats.num_transferred_files, fname);
+			}
+		}
+#endif
 	}
 
 	if (flush_write_file(fd) < 0)
 		goto report_write_error;
 
 #ifdef HAVE_FTRUNCATE
-	if (inplace && fd != -1
-	 && ftruncate(fd, offset) < 0) {
-		rsyserr(FERROR_XFER, errno, "ftruncate failed on %s",
-			full_fname(fname));
+	if (offset == total_size && inplace && fd != -1) {
+		if (ftruncate(fd, offset) < 0)
+			rsyserr(FERROR_XFER, errno, "receive_data: ftruncate failed on %s",
+				full_fname(fname));
 	}
 #endif
 
@@ -298,7 +412,23 @@
 
 	if (fd != -1 && offset > 0 && sparse_end(fd) != 0) {
 	    report_write_error:
-		rsyserr(FERROR_XFER, errno, "write failed on %s",
+		// This next line is a temporary hack. It looks like receiver and generator messages sent to rsyserr aren't getting displayed:
+		/*
+receive_data(x): 10A270.dmg [No space left on device]
+rsyserr(x): write failed on %s [No space left on device]
+rsyserr(x): writefd_unbuffered failed to write %ld bytes [%s] [Broken pipe]
+rsync: writefd_unbuffered failed to write 4 bytes [sender]: Broken pipe (32)
+
+		
+		*/
+		fprintf(stderr, "rsync: receive_data: write failed on %s [;;;TTS;;;%lld;;;FC;;;%d;;;]: %s (%d)\n", full_fname(fname), (stats.total_transferred_size - offset), stats.num_transferred_files, strerror(errno), errno);
+		fflush(stderr);
+		usleep(250000); // Sleep for a quarter of a second -- this is temporary, just to see if these problems are caused by calling exit_cleanup() too soon:
+//		05/20 16:30:07	rsync: connection unexpectedly closed (2030 bytes received so far) [sender] (10001)
+//		05/20 16:30:07	Synchronization Engine exited with status 12
+//		05/20 16:30:07	Synchronization Engine exited with a non-zero exit status: 12. (1059)
+
+		rsyserr(FERROR_XFER, errno, "receive_data: write failed on %s",
 			full_fname(fname));
 		exit_cleanup(RERR_FILEIO);
 	}
@@ -312,14 +442,21 @@
 	read_buf(f_in, sender_file_sum, checksum_len);
 	if (verbose > 2)
 		rprintf(FINFO,"got file_sum\n");
+//	char *csumSrc = printableChecksum(sender_file_sum);
+//	char *csumDst = printableChecksum(file_sum1);
+//	fprintf(stderr, "DEBUG: Comparing checksums for %s; source (while sending): %s, dest (while writing): %s\n", full_fname(fname), csumSrc, csumDst);
+//	free(csumSrc);
+//	free(csumDst);
 	if (fd != -1 && memcmp(file_sum1, sender_file_sum, checksum_len) != 0)
 		return 0;
 	return 1;
 }
 
 
+
 static void discard_receive_data(int f_in, OFF_T length)
 {
+	rprintf(FINFO, "S;;;DISCARD;;;LEN;;;%lld\n", length);
 	receive_data(f_in, NULL, -1, 0, NULL, -1, length);
 }
 
@@ -342,7 +479,7 @@
 			 * partial-dir must be on the same drive. */
 			if (do_rename(partialptr, fname) < 0) {
 				rsyserr(FERROR_XFER, errno,
-					"rename failed for %s (from %s)",
+					"handle_delayed_updates: rename failed for %s (from %s)",
 					full_fname(fname), partialptr);
 			} else {
 				if (remove_source_files
@@ -444,9 +581,11 @@
 #endif
 	int ndx, recv_ok;
 
-	if (verbose > 2)
+	if (verbose > 2) {
 		rprintf(FINFO, "recv_files(%d) starting\n", cur_flist->used);
-
+		fprintf(stderr, "DEBUG: [recv_files: %s] rcvr_is_non_local_server: %d\n", who_am_i(), rcvr_is_non_local_server);
+	}
+	
 	if (delay_updates)
 		delayed_bits = bitbag_create(cur_flist->used + 1);
 
@@ -484,14 +623,22 @@
 		if (verbose > 2)
 			rprintf(FINFO, "recv_files(%s)\n", fname);
 
+		initial_stats = stats;
 #ifdef SUPPORT_XATTRS
-		if (iflags & ITEM_REPORT_XATTR && do_xfers)
+		if (iflags & ITEM_REPORT_XATTR && do_xfers) {
 			recv_xattr_request(file, f_in);
+			// BOMBICH: I've added logic to set_file_attrs that will prevent 
+			// it from running set_xattrs unless they've actually changed. So
+			// here we indicate that xattrs should be copied
+			file->flags |= FLAG_XATTRS_SENT;
+		}
 #endif
 
 		if (!(iflags & ITEM_TRANSFER)) {
 			maybe_log_item(file, iflags, itemizing, xname);
 #ifdef SUPPORT_XATTRS
+			if (verbose > 1)
+				fprintf(stderr, "recv_files: Calling set_file_attrs: ITEM_REPORT_XATTR: %d, do_xfers: %d (%s)\n", iflags & ITEM_REPORT_XATTR, do_xfers, file->basename);
 			if (preserve_xattrs && iflags & ITEM_REPORT_XATTR && do_xfers)
 				set_file_attrs(fname, file, NULL, fname, 0);
 #endif
@@ -528,8 +675,18 @@
 
 		if (!am_server && do_progress)
 			set_current_file_index(file, ndx);
-		stats.num_transferred_files++;
-		stats.total_transferred_size += F_LENGTH(file);
+		
+#ifdef PARSEABLE_OUTPUT
+		if (!rcvr_is_non_local_server) {
+			struct timeval now;
+			gettimeofday(&now, NULL);
+			unsigned long time_diff = msdiff(&last_update, &now);
+			if (time_diff > 500) {
+				last_update = now;
+				fprintf(stderr, "S;;;STATS;;;TTS;;;%lld;;;FC;;;%d;;;CF;;;%s\n", stats.total_transferred_size, stats.num_transferred_files, fname);
+			}
+		}
+#endif
 
 		cleanup_got_literal = 0;
 
@@ -555,7 +712,7 @@
 		}
 
 		if (!do_xfers) { /* log the transfer */
-			log_item(FCLIENT, file, &stats, iflags, NULL);
+			log_item(FLOG, file, &stats, iflags, NULL);
 			if (read_batch)
 				discard_receive_data(f_in, F_LENGTH(file));
 			continue;
@@ -591,8 +748,8 @@
 			default:
 				if (fnamecmp_type >= basis_dir_cnt) {
 					rprintf(FERROR,
-						"invalid basis_dir index: %d.\n",
-						fnamecmp_type);
+						"invalid basis_dir index: %d. %s\n",
+						fnamecmp_type, full_fname(fname));
 					exit_cleanup(RERR_PROTOCOL);
 				}
 				pathjoin(fnamecmpbuf, sizeof fnamecmpbuf,
@@ -619,9 +776,10 @@
 				fnamecmp = fname;
 		}
 
-		initial_stats = stats;
+		if (verbose > 1)
+			fprintf(stderr, "recv_files: Location identified for incoming file: %s of length: %.0f\n", fnamecmp, (double)F_LENGTH(file));
 
-		/* open the file */
+		/* open the (existing) file (at the destination) */
 		fd1 = do_open(fnamecmp, O_RDONLY, 0);
 
 		if (fd1 == -1 && protocol_version < 29) {
@@ -639,14 +797,13 @@
 			}
 		}
 
-		updating_basis_or_equiv = inplace
-		    && (fnamecmp == fname || fnamecmp_type == FNAMECMP_BACKUP);
-
 		if (fd1 == -1) {
+			if (verbose > 1 && errno != ENOENT)
+				fprintf(stderr, "recv_files: Failed to open %s for reading (%d), setting size = 0\n", full_fname(fnamecmp), errno);
 			st.st_mode = 0;
 			st.st_size = 0;
 		} else if (do_fstat(fd1,&st) != 0) {
-			rsyserr(FERROR_XFER, errno, "fstat %s failed",
+			rsyserr(FERROR_XFER, errno, "recv_files: fstat %s failed",
 				full_fname(fnamecmp));
 			discard_receive_data(f_in, F_LENGTH(file));
 			close(fd1);
@@ -655,6 +812,9 @@
 			continue;
 		}
 
+		updating_basis_or_equiv = inplace
+		    && (fnamecmp == fname || fnamecmp_type == FNAMECMP_BACKUP);
+
 		if (fd1 != -1 && S_ISDIR(st.st_mode) && fnamecmp == fname) {
 			/* this special handling for directories
 			 * wouldn't be necessary if robust_rename()
@@ -690,12 +850,30 @@
 			file->mode = dest_mode(file->mode, st.st_mode,
 					       dflt_perms, exists);
 		}
-
+		
 		/* We now check to see if we are writing the file "inplace" */
 		if (inplace)  {
 			fd2 = do_open(fname, O_WRONLY|O_CREAT, 0600);
+#ifdef SUPPORT_FORCE_CHANGE
 			if (fd2 == -1) {
-				rsyserr(FERROR_XFER, errno, "open %s failed",
+				stat_x sx;
+				char *parent = dirname(fnamecmp);
+				if (!parent && do_stat(parent, &sx.st) < 0)
+					rprintf(FINFO, "recv_files: Failed to stat %s!\n", full_fname(parent));
+				else {
+//					fprintf(stderr, "recv_files: Calling make_mutable on %s. Mode: %o, fileflags: %d\n", full_fname(parent), sx.st.st_mode, sx.st.st_flags);
+					if (force_change && make_mutable(parent, sx.st.st_mode, sx.st.st_flags, force_change) > 0) {
+						fd2 = do_open(fname, O_WRONLY|O_CREAT, 0600);
+						undo_make_mutable(parent, sx.st.st_flags);
+					} else if (force_change && !(force_change & SYS_IMMUTABLE) && sx.st.st_flags & SYS_IMMUTABLE) {
+						rsyserr(FERROR_XFER, errno, "recv_files: Failed to unlock %s, it is system immutable.", full_fname(parent));
+					}
+				}
+			}
+#endif
+
+			if (fd2 == -1) {
+				rsyserr(FERROR_XFER, errno, "recv_files: open %s failed",
 					full_fname(fname));
 			}
 		} else {
@@ -716,19 +894,29 @@
 		/* log the transfer */
 		if (log_before_transfer)
 			log_item(FCLIENT, file, &initial_stats, iflags, NULL);
-		else if (!am_server && verbose && do_progress)
+		else if (!am_server && verbose > 1 && do_progress)
 			rprintf(FINFO, "%s\n", fname);
 
 		/* recv file data */
 		recv_ok = receive_data(f_in, fnamecmp, fd1, st.st_size,
 				       fname, fd2, F_LENGTH(file));
 
+		if (verbose > 1) {
+			struct stat vst;
+			if (fd2 == -1 || fstat(fd2, &vst) < 0)
+				fprintf(stderr, "recv_files: Failed to stat %s!\n", full_fname(inplace ? fname : fnametmp));
+			else 
+				fprintf(stderr, "recv_files: Finished receive_data, file size at %s is %.0f\n", full_fname(inplace ? fname : fnametmp), (double)vst.st_size);
+		}
+		
+		iflags |= recv_ok ? ITEM_HAD_ERRORS_DEST : 0;
 		log_item(log_code, file, &initial_stats, iflags, NULL);
 
 		if (fd1 != -1)
 			close(fd1);
 		if (close(fd2) < 0) {
-			rsyserr(FERROR, errno, "close failed on %s",
+			fprintf(stderr, "recv_files: close failed on %s (%d)\n", full_fname(fnametmp), errno);
+			rsyserr(FERROR, errno, "recv_files: close failed on %s",
 				full_fname(fnametmp));
 			exit_cleanup(RERR_FILEIO);
 		}
@@ -743,6 +931,7 @@
 				do_unlink(partialptr);
 				handle_partial_dir(partialptr, PDIR_DELETE);
 			}
+			stats.num_transferred_files++;
 		} else if (keep_partial && partialptr) {
 			if (!handle_partial_dir(partialptr, PDIR_CREATE)) {
 				rprintf(FERROR,
@@ -795,7 +984,7 @@
 				}
 				rprintf(msgtype,
 					"%s: %s failed verification -- update %s%s.\n",
-					errstr, local_name ? f_name(file, NULL) : fname,
+					errstr, local_name ? full_fname(f_name(file, NULL)) : full_fname(fname),
 					keptstr, redostr);
 			}
 			if (!redoing) {
@@ -822,5 +1011,6 @@
 	if (verbose > 2)
 		rprintf(FINFO,"recv_files finished\n");
 
+//	rprintf(FINFO, "Performance (receiver): %lu\n", (unsigned long)stats.perf);
 	return 0;
 }
diff -Naur -X diff_ignore rsync-3.0.6_base/rsync.c rsync/rsync.c
--- rsync-3.0.6_base/rsync.c	2009-06-18 17:30:46.000000000 -0400
+++ rsync/rsync.c	2018-10-13 16:17:50.000000000 -0400
@@ -31,6 +31,7 @@
 extern int dry_run;
 extern int preserve_acls;
 extern int preserve_xattrs;
+extern int force_change;
 extern int preserve_perms;
 extern int preserve_fileflags;
 extern int preserve_executability;
@@ -44,16 +45,21 @@
 extern int protocol_version;
 extern int uid_ndx;
 extern int gid_ndx;
+extern int ownershipDisabledOnDest;
 extern int inc_recurse;
 extern int inplace;
 extern int flist_eof;
 extern int keep_dirlinks;
 extern int make_backups;
+extern int delete_modified;
+extern uid_t receiver_uid;
 extern struct file_list *cur_flist, *first_flist, *dir_flist;
 extern struct chmod_mode_struct *daemon_chmod_modes;
 #ifdef ICONV_OPTION
 extern char *iconv_opt;
 #endif
+extern int detect_case_conflicts;
+
 
 #ifdef ICONV_CONST
 iconv_t ic_chck = (iconv_t)-1;
@@ -297,6 +303,7 @@
 		send_msg_int(MSG_FLIST, ndx);
 		start_flist_forward(f_in);
 		flist = recv_file_list(f_in);
+		//fprintf(stderr, "DEBUG: [%s]read_ndx_and_attrs received %d items\n", who_am_i(), flist->used);
 		flist->parent_ndx = ndx;
 		stop_flist_forward();
 		verbose = save_verbose;
@@ -332,8 +339,8 @@
 		int i = ndx - cur_flist->ndx_start;
 		if (i < 0 || !S_ISREG(cur_flist->files[i]->mode)) {
 			rprintf(FERROR,
-				"received request to transfer non-regular file: %d [%s]\n",
-				ndx, who_am_i());
+				"received request to transfer non-regular file (%s): %d [%s]\n",
+				cur_flist->files[i]->basename, ndx, who_am_i());
 			exit_cleanup(RERR_PROTOCOL);
 		}
 	}
@@ -382,12 +389,23 @@
 /* Set a file's st_flags. */
 static int set_fileflags(const char *fname, uint32 fileflags)
 {
-	if (do_chflags(fname, fileflags) != 0) {
-		rsyserr(FERROR_XFER, errno,
-			"failed to set file flags on %s",
-			full_fname(fname));
+//	struct stat sx3;
+//	link_stat(fname, &sx3, 0);
+//	fprintf(stderr, "DEBUG: set_fileflags(): Stat of %s before setting fileflags, mode: %o, fileflags: %d\n", fname, sx3.st_mode, sx3.st_flags);
+	if (do_chflags(fname, fileflags) != 0) { // && !(!am_root && errno == EACCES)
+		int savedErrno = errno;
+		if (errno != EROFS)
+			rsyserr(FERROR_XFER, errno,
+					"set_fileflags: failed to set file flags (%d) on %s", fileflags,
+					full_fname(fname));
+		errno = savedErrno;
+		
+//		link_stat(fname, &sx3, 0);
+//		fprintf(stderr, "DEBUG: set_fileflags(): Stat of %s after FAIL chflags(%s, %d), mode: %o, fileflags: %d\n", fname, fname, fileflags, sx3.st_mode, sx3.st_flags);
 		return 0;
 	}
+//	link_stat(fname, &sx3, 0);
+//	fprintf(stderr, "DEBUG: set_fileflags(): Stat of %s after chflags(%s, %d), mode: %o, fileflags: %d\n", fname, fname, fileflags, sx3.st_mode, sx3.st_flags);
 
 	return 1;
 }
@@ -395,18 +413,25 @@
 /* Remove immutable flags from an object, so it can be altered/removed. */
 int make_mutable(const char *fname, mode_t mode, uint32 fileflags, uint32 iflags)
 {
-	if (S_ISLNK(mode) || !(fileflags & iflags))
+	if (/*S_ISLNK(mode) || */!(fileflags & iflags))
 		return 0;
+//	if (verbose > 1)
+//		fprintf(stderr, "make_mutable[%s]: (%d) %s\n", who_am_i(), fileflags & ~iflags, full_fname(fname));
 	if (!set_fileflags(fname, fileflags & ~iflags))
 		return -1;
+
 	return 1;
 }
 
 /* Undo a prior make_mutable() call that returned a 1. */
 int undo_make_mutable(const char *fname, uint32 fileflags)
 {
-	if (!set_fileflags(fname, fileflags))
+//	if (verbose > 1)
+//		fprintf(stderr, "undo_make_mutable: (%d) %s\n", fileflags, full_fname(fname));
+	if (!set_fileflags(fname, fileflags)) {
+		rsyserr(FERROR, errno, "failed to relock %s", full_fname(fname));
 		return -1;
+	}
 	return 1;
 }
 #endif
@@ -419,12 +444,13 @@
 	int change_uid, change_gid;
 	mode_t new_mode = file->mode;
 	int inherit;
-
+	int became_mutable = 0;
+	
 	if (!sxp) {
 		if (dry_run)
 			return 1;
 		if (link_stat(fname, &sx2.st, 0) < 0) {
-			rsyserr(FERROR_XFER, errno, "stat %s failed",
+			rsyserr(FERROR_XFER, errno, "set_file_attrs: stat %s failed",
 				full_fname(fname));
 			return 0;
 		}
@@ -449,6 +475,12 @@
 	if (daemon_chmod_modes && !S_ISLNK(new_mode))
 		new_mode = tweak_mode(new_mode, daemon_chmod_modes);
 
+#ifdef SUPPORT_FORCE_CHANGE
+//	fprintf(stderr, "set_file_attrs: Calling make_mutable on %s. Mode: %o, fileflags: %d\n", full_fname(fname), sxp->st.st_mode, sxp->st.st_flags);
+	if (force_change)
+		became_mutable = make_mutable(fname, sxp->st.st_mode, sxp->st.st_flags, force_change) > 0;
+#endif
+
 #ifdef SUPPORT_ACLS
 	if (preserve_acls && !S_ISLNK(file->mode) && !ACL_READY(*sxp))
 		get_acl(fname, sxp);
@@ -457,17 +489,41 @@
 #ifdef SUPPORT_XATTRS
 	if (am_root < 0)
 		set_stat_xattr(fname, file, new_mode);
-	if (preserve_xattrs && fnamecmp)
+
+	if (verbose > 1)
+		fprintf(stderr, "set_file_attrs: FLAG_XATTRS_SENT: %d (%s, %s)\n", file->flags & FLAG_XATTRS_SENT, full_fname(fname), fnamecmp);
+	// BOMBICH: I added the "&& file->flags & FLAG_XATTRS_SENT" so rsync doesn't copy xattrs 
+	// in cases where they haven't changed (and the file was not transferred). I also populate 
+	// sxp->st.st_flags with the file_struct's flags so rsync_xal_set has access to the UF_COMPRESSED flag
+	if (preserve_xattrs && fnamecmp && file->flags & FLAG_XATTRS_SENT) {
+		if (verbose > 1)
+			fprintf(stderr, "set_file_attrs: tmpflags: %#x, file flags:%#x (%s)\n", sxp->st.st_flags, F_FFLAGS(file), full_fname(fnamecmp));
+		uint32 tmpflags = sxp->st.st_flags;
+		sxp->st.st_flags = F_FFLAGS(file);
 		set_xattr(fname, file, fnamecmp, sxp);
+		sxp->st.st_flags = tmpflags;
+		if (S_ISDIR(sxp->st.st_mode))
+			link_stat(fname, &sx2.st, 0);
+	}
 #endif
-
 	if (!preserve_times || (S_ISDIR(sxp->st.st_mode) && preserve_times == 1))
 		flags |= ATTRS_SKIP_MTIME;
+	/* Don't set the creation date on the root folder of an HFS+ volume. */
+	if (sxp->st.st_ino == 2 && S_ISDIR(sxp->st.st_mode))
+		flags |= ATTRS_SKIP_CRTIME;
+	//fprintf(stderr, "DEBUG: set_file_attrs: mod time on %s: dest: %d, source: %d\n", fname, sxp->st.st_mtime, file->modtime);
 	if (!(flags & ATTRS_SKIP_MTIME)
+#ifdef SUPPORT_HFS_COMPRESSION
+		&& !(sxp->st.st_flags & UF_COMPRESSED) // setting this flag alters mtime, defer setting mtime to after set_fileflags
+#endif
 	    && cmp_time(sxp->st.st_mtime, file->modtime) != 0) {
+		//fprintf(stderr, "set_file_attrs: Setting mod time on %s\n", full_fname(fname));
 		int ret = set_modtime(fname, file->modtime, sxp->st.st_mode, ST_FLAGS(sxp->st));
+		if (ret < 0 && (S_ISLNK(sxp->st.st_mode) || (receiver_uid != 0 && receiver_uid == sxp->st.st_uid) || (S_ISDIR(sxp->st.st_mode) && errno == EPERM)))
+			fprintf(stderr, "DEBUG: Failed to set modification date on %s: %d\n", full_fname(fname), errno);
+		else
 		if (ret < 0) {
-			rsyserr(FERROR_XFER, errno, "failed to set times on %s",
+			rsyserr(FERROR_XFER, errno, "set_file_attrs: failed to set times on %s",
 				full_fname(fname));
 			goto cleanup;
 		}
@@ -485,9 +541,14 @@
 			updated = 1;
 	}
 
-	change_uid = am_root && uid_ndx && sxp->st.st_uid != (uid_t)F_OWNER(file);
+	change_uid = am_root && uid_ndx && sxp->st.st_uid != (uid_t)F_OWNER(file)
+		&& !ownershipDisabledOnDest;
+		/* Don't change the ownership of the root folder of an HFS+ volume if the owner is already root */
+		//&& !(sxp->st.st_ino == 2 && S_ISDIR(sxp->st.st_mode) && sxp->st.st_uid == 0);
 	change_gid = gid_ndx && !(file->flags & FLAG_SKIP_GROUP)
-		  && sxp->st.st_gid != (gid_t)F_GROUP(file);
+		&& sxp->st.st_gid != (gid_t)F_GROUP(file) && !ownershipDisabledOnDest;
+		/* Don't change the group of the root folder of an HFS+ volume if the group is already wheel */
+		//&& !(sxp->st.st_ino == 2 && S_ISDIR(sxp->st.st_mode) && sxp->st.st_gid == 0);
 #if !defined HAVE_LCHOWN && !defined CHOWN_MODIFIES_SYMLINK
 	if (S_ISLNK(sxp->st.st_mode)) {
 		;
@@ -513,7 +574,7 @@
 			    sxp->st.st_mode, ST_FLAGS(sxp->st)) != 0) {
 				/* We shouldn't have attempted to change uid
 				 * or gid unless have the privilege. */
-				rsyserr(FERROR_XFER, errno, "%s %s failed",
+				rsyserr(FERROR_XFER, errno, "set_file_attrs: %s %s failed",
 				    change_uid ? "chown" : "chgrp",
 				    full_fname(fname));
 				goto cleanup;
@@ -541,11 +602,14 @@
 #endif
 
 #ifdef HAVE_CHMOD
-	if (!BITS_EQUAL(sxp->st.st_mode, new_mode, CHMOD_BITS)) {
+	if (!BITS_EQUAL(sxp->st.st_mode, new_mode, CHMOD_BITS)
+		/* Don't change the mode of the root folder of an HFS+ volume if we didn't set its owner or group */
+		&& !(sxp->st.st_ino == 2 && S_ISDIR(sxp->st.st_mode) && !change_uid && !change_gid)
+		&& (receiver_uid == 0 || receiver_uid == sxp->st.st_uid)) {
 		int ret = am_root < 0 ? 0 : do_chmod(fname, new_mode, ST_FLAGS(sxp->st));
 		if (ret < 0) {
 			rsyserr(FERROR_XFER, errno,
-				"failed to set permissions on %s",
+				"set_file_attrs: failed to set permissions on %s",
 				full_fname(fname));
 			goto cleanup;
 		}
@@ -554,16 +618,39 @@
 	}
 #endif
 
+#ifdef SUPPORT_FORCE_CHANGE
+	if (became_mutable)
+		undo_make_mutable(fname, sxp->st.st_flags);
+#endif
+
 #ifdef SUPPORT_FILEFLAGS
-	if (preserve_fileflags && !S_ISLNK(sxp->st.st_mode)
-	 && sxp->st.st_flags != F_FFLAGS(file)) {
-		uint32 fileflags = F_FFLAGS(file);
+	uint32 fileflags = F_FFLAGS(file);
+	if (flags & ATTRS_STRIP_RESTRICTED)
+		fileflags &= ~(SF_RESTRICTED|SF_NOUNLINK);
+	if (preserve_fileflags /*&& !S_ISLNK(sxp->st.st_mode)*/
+	 && (receiver_uid == 0 || receiver_uid == sxp->st.st_uid)
+	 && sxp->st.st_flags != fileflags) {
+		if (verbose > 1)
+			fprintf(stderr, "set_file_attrs: Calling set_fileflags: %#x, prev flags: %#x (%s)\n", fileflags, sxp->st.st_flags, full_fname(fname));
 		if (flags & ATTRS_DELAY_IMMUTABLE)
 			fileflags &= ~ALL_IMMUTABLE;
 		if (sxp->st.st_flags != fileflags
 		 && !set_fileflags(fname, fileflags))
 			goto cleanup;
 		updated = 1;
+#ifdef SUPPORT_HFS_COMPRESSION
+		if (verbose > 1)
+			fprintf(stderr, "set_file_attrs: Calling set_modtime on %s\n", full_fname(fname));
+		//fprintf(stderr, "set_file_attrs2: Setting mod time on %s\n", full_fname(fname));
+		int ret = set_modtime(fname, file->modtime, new_mode, fileflags);
+		if (ret < 0 && !(S_ISDIR(sxp->st.st_mode) && errno == EPERM)) {
+			rsyserr(FERROR_XFER, errno, "set_file_attrs: failed to set times on %s",
+				full_fname(fname));
+			goto cleanup;
+		}
+		if (ret != 0)
+			file->flags |= FLAG_TIME_FAILED;
+#endif
 	}
 #endif
 
@@ -621,7 +708,27 @@
 		goto do_set_file_attrs;
 	}
 
-	if (make_backups > 0 && overwriting_basis) {
+	if (detect_case_conflicts) {
+		int fd = open(fname, O_RDONLY);
+		if (fd > 0) {
+			char realpath[MAXPATHLEN];
+			int ret = fcntl(fd, F_GETPATH, &realpath);
+			close(fd);
+			if (ret == 0) {
+				char *mypath = normalize_path((char *)fname, False, NULL);
+				if (strcmp(mypath, realpath) != 0) {
+					fprintf(stderr, "Case conflict detected at %s: \"%s\"\n", full_fname(fname), realpath);
+					char new_fname_buf[MAXPATHLEN];
+					snprintf(new_fname_buf, MAXPATHLEN, "%s.XXXXXX", fname);
+					fname = mktemp(new_fname_buf);
+				}
+				if (mypath != fname)
+					free(mypath);
+			}
+		}
+	}
+	
+	if (delete_modified == 0 && make_backups > 0 && overwriting_basis) {
 		if (!make_backup(fname))
 			return 1;
 		if (fnamecmp == fname)
@@ -639,7 +746,7 @@
 	ret = robust_rename(fnametmp, fname, temp_copy_name,
 			    file->mode & INITACCESSPERMS);
 	if (ret < 0) {
-		rsyserr(FERROR_XFER, errno, "%s %s -> \"%s\"",
+		rsyserr(FERROR_XFER, errno, "finish_transfer: %s %s -> \"%s\"",
 			ret == -2 ? "copy" : "rename",
 			full_fname(fnametmp), fname);
 		if (!partialptr || (ret == -2 && temp_copy_name)
@@ -651,9 +758,13 @@
 	if (ret == 0) {
 		/* The file was moved into place (not copied), so it's done. */
 #ifdef SUPPORT_FILEFLAGS
-		if (preserve_fileflags && F_FFLAGS(file) & ALL_IMMUTABLE)
+		if (preserve_fileflags && F_FFLAGS(file) & ALL_IMMUTABLE /*&& !S_ISLNK(file->mode)*/)
 			set_fileflags(fname, F_FFLAGS(file));
 #endif
+//		struct stat sx3;
+//		link_stat(fname, &sx3, 0);
+//		fprintf(stderr, "DEBUG: finish_transfer(): Restat of %s after move, new modtime: %d\n", fname, sx3.st_mtime);
+	
 		return 1;
 	}
 	/* The file was copied, so tweak the perms of the copied file.  If it
@@ -672,6 +783,9 @@
 		}
 		handle_partial_dir(temp_copy_name, PDIR_DELETE);
 	}
+//	struct stat sx3;
+//	link_stat(fname, &sx3, 0);
+//	fprintf(stderr, "DEBUG: finish_transfer(): Restat of %s after copy, new modtime: %d\n", fname, sx3.st_mtime);
 	return 1;
 }
 
diff -Naur -X diff_ignore rsync-3.0.6_base/rsync.csreqs rsync/rsync.csreqs
--- rsync-3.0.6_base/rsync.csreqs	1969-12-31 19:00:00.000000000 -0500
+++ rsync/rsync.csreqs	2014-12-06 21:12:18.000000000 -0500
@@ -0,0 +1 @@
+designated => certificate root = H"2796bae63f1801e277261ba0d77770028f20eee4" or certificate root = H"611E5B662C593A08FF58D14AE22452D198DF6C60" and certificate leaf[subject.O] = "Bombich Software"* and identifier "rsync"
\ No newline at end of file
